var select_vehicle = null;
var toolType = TOOL_TYPE_DEFAULT;
var current_marker = null;
var current_infowin = null;
var current_retangle = null;
// var mappoint = null;
// var mapsource = null;
// var mapvector = null;
var maplabel =null;
var newlonlat=[];
var newinfowin=null;
var adresscity=null;

function getTextWidth(str) {
	var span = document.getElementById('textWidth');
	span.innerHTML = str;
	var w = span.offsetWidth;
	return w;
}

var gmap = function(div_map, center_point, zoom) {
	console.log(JSON.stringify(center_point))
	// $.ajax({
	// 		 url:' http://api.map.baidu.com/reverse_geocoding/v3/?ak=bwaHmV44hWGCe7tNFYoT7dtoxQgoS28l&mcode=BA:AD:09:3A:82:82:9F:B4:32:A7:B2:8C:B4:CC:F0:E9:F3:7D:AE:58;plus.H5ED5A069&output=json&coordtype=wgs84ll&location='+center_point[1]+','+center_point[0],
	//         // url: 'https://api.map.baidu.com/geocoder/v2/?ak=bwaHmV44hWGCe7tNFYoT7dtoxQgoS28l&location=' + 39.686681 + ',' + -104.978827 + '&output=json&coordtype=wgs84ll',
	//         data: {},
	//         header: {
	//           'Content-Type': 'application/json'
	//         },
	//         success: function (res) {
	// 		var rs = JSON.parse(res);
	// 		var addComp=  rs.result.addressComponent;
	// 		adresscity=addComp.province + ", " + addComp.city + ", " + addComp.district + ", " + addComp.street + ", " + addComp.street_number;
	// 		console.log(addComp.province + ", " + addComp.city + ", " + addComp.district + ", " + addComp.street + ", " + addComp.street_number)
	//         }
	//       })
	// this.map=new ol.Map({
	// 		layers: [
	// 			new ol.layer.Tile({
	// 				source: new ol.source.OSM()
	// 			})
	// 		],
	// 		target: document.getElementById('container'),
	// 		view: new ol.View({
	// 			center:center_point,
	// 			zoom: zoom
	// 		})
	// 	});


	var openStreetMapLayer = new ol.layer.Tile({
		//使用XYZ的方式加载瓦片图
		source: new ol.source.XYZ({
			//OpenStreetMap的瓦片URL
			url: 'http://{a-c}.tile.openstreetmap.org/{z}/{x}/{y}.png'
		})
	});
	//创建地图实例
	this.map = new ol.Map({
		layers: [openStreetMapLayer], //瓦片地图
		view: new ol.View({
			center: center_point,
			projection: 'EPSG:4326',
			zoom: zoom,
			// mapMaker: false,
			// noClear: true,
			// fullscreenControl: false,
			// streetViewControl: false
		}),
		target: document.getElementById('container'),
	});
	// //创建一个点  
	// var point = new ol.Feature({
	// 	geometry: new ol.geom.Point(center_point)
	// });
	// //设置标记
	// point.setStyle(new ol.style.Style({
	// 	image: new ol.style.Icon({
	// 		anchor: [0.5, 1],
	// 		src: './images/objects/normal_offline_0.gif'
	// 	})
	// }));
	// //实例化一个矢量图层Vector作为绘制层
	// var source = new ol.source.Vector({
	// 	features: [point]
	// });
	// //创建一个图层
	// var vector = new ol.layer.Vector({
	// 	source: source
	// });
	// //将绘制层添加到地图容器中
	// this.map.addLayer(vector);

	// this.map = new google.maps.Map(div_map, {
	//     zoom: zoom,       //缩放级别
	//     center: center_point,   //中心点
	//     mapTypeId: google.maps.MapTypeId.ROADMAP,   //地图初始类型
	//     mapMaker: false,
	//     noClear: true,
	//     fullscreenControl: false,
	//     streetViewControl: false
	// });
	//逆地址解析
	// this.geocoder = new google.maps.Geocoder();
	this.vehicles = [];
	this.pois = [];
	this.geos = [];
	this.markers = [];
	this.poi_markers = [];
	this.markerClusterer = null;
	this.showLocation = null;
	this.mapClick = null;
}

gmap.prototype.setCenter = function(lon, lat) {
	point = ol.proj.fromLonLat([lat, lon])
	// point = new google.maps.LatLng(lat, lon);
	this.map.setCenter(point);
};

// 获取地址后的函数处理
gmap.prototype.setShowLocation = function(fun) {
	this.showLocation = fun;
}

function vehicleMarker(vehicle, if_track, if_show_line) {
	this.obj_id = vehicle.did;
	this.obj_name = vehicle.vehicleName;
	this.lon = vehicle.activeGpsData.lon;
	this.lat = vehicle.activeGpsData.lat;
	this.speed = vehicle.activeGpsData.speed;
	this.direct = vehicle.activeGpsData.direct;
	this.if_track = if_track;
	this.if_show_line = if_show_line;
	this.track_line = null;
	this.track_lines = [];
	this.content = "";
	this.marker_ = null;
	this.infowin_ = null;
}

function poiMarker(poi) {
	this.poi_id = poi.PointID;
	this.poi_name = poi.PointName;
	this.poi_type = poi.PointType;
	this.icon = poi.Icon;
	this.lon = poi.Lon;
	this.lat = poi.Lat;
	this.remark = poi.remark;
	this.marker_ = null;
}
//加载设备
gmap.prototype.addVehicles = function(vehicles, is_infowin, if_playback) {
	console.log("触发加载设备")
	var v = null;
	var latLng = null;
	var newdata=[];
	var icon = "";
	var title = "";
	var features = [];
	for (var i = 0; i < vehicles.length; i++) {
		if (vehicles[i] != null) {
			//id为字符串
			var v = this.vehicles[vehicles[i].did];
			// 判断车辆是否存在，存在则更新数据，不存在则添加
			if (v != null) {
				this.updateVehicle(vehicles[i], false, false, false, '#FF0000', 3, if_playback);
			} else {
				//                if (this.map.getMapTypeId() == google.maps.MapTypeId.SATELLITE || this.map.getMapTypeId() == google.maps.MapTypeId.HYBRID) {
				//                    latLng = new google.maps.LatLng(vehicles[i].active_gps_data.lat, vehicles[i].active_gps_data.lon);
				//                } else {
				console.log('gmap - lat: ' + vehicles[i].activeGpsData.lat + ', lon: ' + vehicles[i].activeGpsData.lon);
				// 
				newdata.push(vehicles[i])
				newlonlat.push(vehicles[i])
				// console.log(JSON.stringify(newdata))
				// latLng = new google.maps.LatLng(vehicles[i].activeGpsData.lat, vehicles[i].activeGpsData.lon);
				latLng = [vehicles[i].activeGpsData.lon, vehicles[i].activeGpsData.lat];
				console.log(JSON.stringify(latLng))
				//                }
				v = new vehicleMarker(vehicles[i], false, false);
				// title = vehicles[i].vehicleName;
				// //              var offset = getTextWidth(title) / 2; 
				// //              console.log(title+","+offset);
				icon = getIcon(vehicles[i], MAP_TYPE_GOOGLE, if_playback);
				var mappoint = new ol.Feature({
					id:vehicles[i].did,
					geometry: new ol.geom.Point(latLng)
					// name:vehicles[i].did
				});
				//设置标记
				mappoint.setStyle(new ol.style.Style({
					image: new ol.style.Icon({
						anchor: [0.5, 1],
						src: icon
					})
				}));
				features.push(mappoint);
				if (!if_playback) {
					// console.log("加载车辆信息窗口")
					// var aress;
					// $.ajax({
					// url:' http://api.map.baidu.com/reverse_geocoding/v3/?ak=bwaHmV44hWGCe7tNFYoT7dtoxQgoS28l&mcode=BA:AD:09:3A:82:82:9F:B4:32:A7:B2:8C:B4:CC:F0:E9:F3:7D:AE:58;plus.H5ED5A069&output=json&coordtype=wgs84ll&location='+vehicles[i].activeGpsData.glat+','+vehicles[i].activeGpsData.glon,
					//    // url: 'https://api.map.baidu.com/geocoder/v2/?ak=bwaHmV44hWGCe7tNFYoT7dtoxQgoS28l&location=' + 39.686681 + ',' + -104.978827 + '&output=json&coordtype=wgs84ll',
					//    data: {},
					//    header: {
					//      'Content-Type': 'application/json'
					//    },
					//    success: function (res) {
					// 			var rs = JSON.parse(res);
					// 			var addComp=  rs.result.addressComponent;
					// 			aress=addComp.province + ", " + addComp.city + ", " + addComp.district + ", " + addComp.street + ", " + addComp.street_number;
					// 			content = getVehicleContent(vehicles[i],aress);
					// 			// console.log(addComp.province + ", " + addComp.city + ", " + addComp.district + ", " + addComp.street + ", " + addComp.street_number)
					//    }
					//  })
					
					//添加判断设备 传进点击事件  如同相同则显示  否则隐藏
					// this.maplabel = document.createElement("div");
					// this.maplabel.innerHTML = content;

					// document.body.appendChild(this.maplabel);
					// var infowin = new ol.Overlay({
					// 	element: this.maplabel,
					// 	// autoPan: true,
					// 	offset: [0, -225],
					// 	// position: latLng,
					// 	positioning: 'top-center'
					// });
					// this.map.addOverlay(infowin);
					// infowin.setPosition(undefined)
				}
				this.vehicles[vehicles[i].did] = v;
				this.markers.push(this.mappoint);
			}
		}
	}
	//实例化一个矢量图层Vector作为绘制层
	var mapsource = new ol.source.Vector({
		features: features
	});
	//创建一个图层
	mapvector = new ol.layer.Vector({
		source: mapsource,
	});
	//将绘制层添加到地图容器中
	mapvector.set("layerId","did")
	mapvector.setZIndex(100);
	this.map.addLayer(mapvector);
  //监听点击事件
  let that = this;
  that.map.on("click", function(e) {
  	// var coordinate = e.coordinate;  //点击的经纬度
  	var pixel = that.map.getEventPixel(e.originalEvent);
  	        that.map.forEachFeatureAtPixel(pixel,function(feature){
  				newdata.forEach(e=>{
  					// console.log(JSON.stringify(feature.get("id")))
  					if(e.did==feature.get("id")){
						var aress;
						$.ajax({
						url:' http://api.map.baidu.com/reverse_geocoding/v3/?ak=bwaHmV44hWGCe7tNFYoT7dtoxQgoS28l&mcode=BA:AD:09:3A:82:82:9F:B4:32:A7:B2:8C:B4:CC:F0:E9:F3:7D:AE:58;plus.H5ED5A069&output=json&coordtype=wgs84ll&location='+e.activeGpsData.glat+','+e.activeGpsData.glon,
						   // url: 'https://api.map.baidu.com/geocoder/v2/?ak=bwaHmV44hWGCe7tNFYoT7dtoxQgoS28l&location=' + 39.686681 + ',' + -104.978827 + '&output=json&coordtype=wgs84ll',
						   data: {},
						   header: {
						     'Content-Type': 'application/json'
						   },
						   success: function (res) {
									var rs = JSON.parse(res);
									var addComp=  rs.result.addressComponent;
									aress=addComp.province + ", " + addComp.city + ", " + addComp.district + ", " + addComp.street + ", " + addComp.street_number;
									content = getVehicleContent(e,aress);
									// console.log(addComp.province + ", " + addComp.city + ", " + addComp.district + ", " + addComp.street + ", " + addComp.street_number)
						   }
						 })
  						
  						var newlatLng = [e.activeGpsData.lon, e.activeGpsData.lat];
  						console.log(JSON.stringify(newlatLng))
  						this.maplabel = document.createElement("div");
  						this.maplabel.innerHTML = content;
  						document.body.appendChild(this.maplabel);
  						newinfowin = new ol.Overlay({
  							element: this.maplabel,
  							// autoPan: true,
  							offset: [0, -225],
  							position: newlatLng,
  							// positioning: 'top-center'
  						});
  						that.map.addOverlay(newinfowin);
  						newinfowin.setPosition(newlatLng)
						newinfowin.setPositioning("top-center");
  					 //    var closer = document.getElementById('popup-closer');
  						// //信息窗口关闭
  						// closer.onclick = function(e) {
  						// 	console.log("信息窗口关闭")
  						// 	console.log(JSON.stringify(e))
  						// 	newinfowin.setPosition(undefined);
  						// 	closer.blur();
  						// 	return false;
  						// };
  					}
  				})
  	        });
  	// if (select_vehicle) {
  	// 	select_vehicle.infowin_.close();
  	// }
  });
	//  if (this.markerClusterer == null) {
	//      //        this.markerClusterer = new MarkerClusterer(this.map, this.markers);
	//      this.markerClusterer = new MarkerClusterer(this.map, this.markers, { maxZoom: 14 });
	//  } else {
	//      this.markerClusterer.addMarkers(this.markers);
	//  }

}
var markerClickFunction = function(v) {
	return function(e) {
		if (select_vehicle) {
			select_vehicle.infowin_.close();
		}
		v.infowin_.open(this.map, this);
		// 设置该车辆为选中车辆
		select_vehicle = v;
	};
};

// 设置地图缩放比例
gmap.prototype.setZoom = function(level) {
	this.map.setZoom(level);
};

// 更新车辆显示
gmap.prototype.updateVehicle = function(vehicle, if_track, if_show_line, if_open_win, color, width, if_playback) {
	var v = this.vehicles[vehicle.did];
	var content = "";
	if (v != null) {
		var oldlatLng;
		var oldGpsTime;
		//        if (this.map.getMapTypeId() == google.maps.MapTypeId.SATELLITE || this.map.getMapTypeId() == google.maps.MapTypeId.HYBRID) {
		//            oldlatLng = new google.maps.LatLng(v.lat, v.lon);
		//        } else {
		// oldlatLng = new google.maps.LatLng(v.lat, v.lon);
		oldlatLng = [v.lat, v.lon]
		//        }
		oldGpsTime = v.gpsTime;
		v.lon = vehicle.activeGpsData.lon;
		v.lat = vehicle.activeGpsData.lat;
		v.gps_time = vehicle.activeGpsData.gpsTime;
		v.speed = vehicle.activeGpsData.speed;
		v.direct = vehicle.activeGpsData.direct;

		var latLng;
		//        if (this.map.getMapTypeId() == google.maps.MapTypeId.SATELLITE || this.map.getMapTypeId() == google.maps.MapTypeId.HYBRID) {
		//            latLng = new google.maps.LatLng(vehicle.active_gps_data.lat, vehicle.active_gps_data.lon);
		//        } else {
		// latLng = new google.maps.LatLng(vehicle.activeGpsData.lat, vehicle.activeGpsData.lon);
		latLng = [vehicle.activeGpsData.lon, vehicle.activeGpsData.lat]
		//        }

		var distance;
		if (v.if_show_line || if_show_line) {
			console.log("更新为true")
			distance = calDistance(oldlatLng.lng(), oldlatLng.lat(), latLng.lng(), latLng.lat());
			if (distance < 2) {
				if (!v.track_line) {
					console.log("折线")
					console.log(JSON.stringify(distance))
					//线
					var polyOptions = {
						strokeColor: color,
						strokeOpacity: 1.0,
						strokeWeight: width
					}
					//折线
					v.track_line = new google.maps.Polyline(polyOptions);
					v.track_line.setMap(this.map);
					var path = v.track_line.getPath();
					path.push(oldlatLng);
					v.track_lines.push(v.track_line);
				}
				var path = v.track_line.getPath();
				path.push(latLng);
				v.track_line.setPath(path);
			} else {
				v.track_line = null;
			}
		}
		title = v.obj_name;
		//		var offset = getTextWidth(title) / 2 + 25;
		var icon = getIcon(vehicle, MAP_TYPE_GOOGLE, if_playback);
		// console.log(JSON.stringify(latLng))
		//更新某个标注的位置,图标    
		// var features = this.mapvector.getSource().getFeatures();
		
		// this.mapvector.getSource().addfeature（feature）;更新的点
		// console.log(JSON.stringify(features[0].values_.id==vehicle.did))
		// var newpoint=[];
	     // console.log(JSON.stringify(newlonlat))
		 // newlonlat.forEach(e=>{
			//  if(e.did==vehicle.did){
			// 	 console.log("123")
			//  }else{
			// 	  console.log("456")
			//  }
		 // })
		//开始
		var layers = this.map.getLayers().getArray();	// 数组
		for(var i = 0 , j = layers.length;i<j;i++){
			var layer = layers[i];
			var layerId = layer.get("layerId");
			if("did"=== layerId){
				var source = layer.getSource();
				var features = source .getFeatures();
				for(var a = 0 , b = features.length;a<b;a++){
					var feature = features[a];
					var id = feature.get("id");
					if(vehicle.did===id){	// 这个id是业务要处理的featureid
						// 先删除
						source.removeFeature(feature);
						// var position = [data.lon , data.lat];
						var point = new ol.Feature({
							id: vehicle.did,
							geometry : new ol.geom.Point(latLng)
						});
						//设置标记
						point.setStyle(new ol.style.Style({
							image: new ol.style.Icon({
								anchor: [0.5, 1],
								src: icon
							})
						}));
						source.addFeature(point);
					}
				}
			}
		}
		//结束
		// //移除上一个点的
		// //  this.mappoint.id=vehicle.did
		// this.mapsource.removeFeature(this.mappoint);
		// this.map.removeLayer(this.mapvector);
		// //创建一个新的点
		// this.mappoint = new ol.Feature({
		// 	// id:vehicle.did
		// 	geometry: new ol.geom.Point(latLng)
		// });
		// //设置标记
		// this.mappoint.setStyle(new ol.style.Style({
		// 	image: new ol.style.Icon({
		// 		anchor: [0.5, 1],
		// 		src: icon
		// 	})
		// }));
		// //实例化一个矢量图层Vector作为绘制层
		// this.mapsource = new ol.source.Vector({
		// 	features: [this.mappoint]
		// });
		// //创建一个图层
		// this.mapvector = new ol.layer.Vector({
		// 	source: this.mapsource
		// });
		// //将绘制层添加到地图容器中
		// this.map.addLayer(this.mapvector);
		

		//更新点的坐标点  图标
		// v.marker_.setPosition(latLng);
		// v.marker_.setIcon(icon);
		// v.marker_.setVisible(true);
		// v.infowin_.setPosition(latLng);
		// v.infowin_.setIcon(icon);
		// v.infowin_.setVisible(true);
		if (!if_playback) {
			//更新信息窗口
			var aress;
			$.ajax({
			url:' http://api.map.baidu.com/reverse_geocoding/v3/?ak=bwaHmV44hWGCe7tNFYoT7dtoxQgoS28l&mcode=BA:AD:09:3A:82:82:9F:B4:32:A7:B2:8C:B4:CC:F0:E9:F3:7D:AE:58;plus.H5ED5A069&output=json&coordtype=wgs84ll&location='+vehicle.activeGpsData.glat+','+vehicle.activeGpsData.glon,
			   // url: 'https://api.map.baidu.com/geocoder/v2/?ak=bwaHmV44hWGCe7tNFYoT7dtoxQgoS28l&location=' + 39.686681 + ',' + -104.978827 + '&output=json&coordtype=wgs84ll',
			   data: {},
			   header: {
			     'Content-Type': 'application/json'
			   },
			   success: function (res) {
						var rs = JSON.parse(res);
						var addComp=  rs.result.addressComponent;
						aress=addComp.province + ", " + addComp.city + ", " + addComp.district + ", " + addComp.street + ", " + addComp.street_number;
						content = getVehicleContent(vehicle,aress, if_playback, v.if_track);
						// console.log(addComp.province + ", " + addComp.city + ", " + addComp.district + ", " + addComp.street + ", " + addComp.street_number)
			   }
			 })
			
			console.log("更新信息窗口")
			// console.log(JSON.stringify(content))
			// newinfowin.setPosition(undefined);
			// closer.blur();
			this.maplabel = document.createElement("div");
			this.maplabel.innerHTML = content;
			document.body.appendChild(this.maplabel);
			newinfowin = new ol.Overlay({
				element: this.maplabel,
				// autoPan: true,
				offset: [0, -225],
				// position: latLng,
				// positioning: 'top-center'
			});
			this.map.addOverlay(newinfowin);
			newinfowin.setPosition(undefined)
			newinfowin.setPositioning("top-center");
			// var closer = document.getElementById('popup-closer');
			// //信息窗口关闭
			// closer.onclick = function(e) {
			// 	console.log("信息窗口关闭")
			// 	console.log(JSON.stringify(e))
			// 	newinfowin.setPosition(undefined);
			// 	closer.blur();
			// 	return false;
			// }
			// this.maplabel = document.createElement("div");
			// this.maplabel.innerHTML = content;
			// document.body.appendChild(this.maplabel);
			// var infowin = new ol.Overlay({
			// 	element: this.maplabel,
			// 	// autoPan: true,
			// 	offset: [0, -225],
			// 	position: latLng,
			// 	positioning: 'top-center'
			// });
			// this.map.addOverlay(infowin);
			// infowin.setPosition(latLng)
			// v.infowin_ = infowin;
   //          this.maplabel.innerHTML = content;
			// v.infowin_.setContent(content);
		}
		if (v.if_track || if_track) {
			//返回当前视口的西南纬度/经度和东北纬度/经度：
			// var bounds = this.map.getBounds();
			// if (v.lon < bounds.getSouthWest().lng() || v.lon > bounds.getNorthEast().lng() ||
			// 	v.lat < bounds.getSouthWest().lat() || v.lat > bounds.getNorthEast().lat()) {
			//设置地图中心点
			// this.map.setCenter(latLng);
			// this.map.getView().setCenter(latLng)
			// }
		}

		if (if_open_win) {
			//将信息窗口打开
			// infowin_.setPosition(latLng);
			// this.map.addOverlay(infowin_);
			// v.infowin_.open(this.map, v.marker_);
		}
		//逆地址转换
		// this.geocoder.geocode({ 'latLng': latLng }, function(results, status) {
		// 	if(status == google.maps.GeocoderStatus.OK) {
		// 		if(results[1]) {
		// 			if(this.showLocation) {
		// 				this.showLocation(results[0].formatted_address);
		// 			}
		// 		}
		// 	} else {
		// 		//alert("Geocoder failed due to: " + status);
		// 	}
		// });        
	}
}
//点击设备
gmap.prototype.findVehicle = function(obj_id, if_track, if_open_win) {
	console.log("点击设备") //obj_id="865265522"
	var v = this.vehicles[obj_id];
	console.log(JSON.stringify(v.lon))
	var content = "";
	if (v != null) {
		var latLng;
		// latLng = new google.maps.LatLng(v.lat, v.lon);
		latLng = [v.lon, v.lat];
		if (if_track) {
			//  缩放级别  地图中心
			// this.map.setZoom(17);
			// this.map.setCenter(latLng);
			this.map.getView().setZoom(17)
			this.map.getView().setCenter(latLng)
		}
		if (if_open_win) {
			if (select_vehicle) {
				select_vehicle.infowin_.setPosition(undefined);
				// closer.blur();
				// select_vehicle.infowin_.close();
			}
			//默认开启
			// v.infowin_.setPosition(latLng);
			// this.map.addOverlay(v.infowin_);
			
			
			// v.infowin_.open(this.map, v.marker_);
			select_vehicle = v;
		}
		// 获取地址
		// this.geocoder.geocode({ 'latLng': new google.maps.LatLng(v.lat, v.lon) }, function(results, status) {
		// 	if(status == google.maps.GeocoderStatus.OK) {
		// 		if(results[1]) {
		// 			if(this.showLocation) {
		// 				this.showLocation(results[0].formatted_address);
		// 			}
		// 		}
		// 	} else {
		// 		//alert("Geocoder failed due to: " + status);
		// 	}
		// });
		return v;
	}
}

gmap.prototype.deleteVehicle = function(obj_id) {
	var v = this.vehicles[obj_id];
	if (v != null) {
		// 从数组中删除对象
		this.vehicles[obj_id] = null;
		v.marker_.setMap(null);
		this.markers.pop(v.marker_);
		if (v.track_line) {
			v.track_line.setMap(null);
		}
		if (v.track_lines) {
			for (var i = 0; i < v.track_lines.length; i++) {
				v.track_lines[i].setMap(null);
			}
		}
	}
}

gmap.prototype.clearVehicle = function() {
	for (var i = 0; i < this.markers.length; i++) {
		this.markers[i].setMap(null);
	}
	for (key in this.vehicles) {
		if (this.vehicles[key].track_line) {
			this.vehicles[key].track_line.setMap(null);
		}
	}
	this.vehicles = [];
	this.markers = [];
}

gmap.prototype.toggleVehicle = function(id) {
	console.log("跟踪")
	var v = this.vehicles[id];
	if (v) {
		if (!v.if_track) {
			//删除其他跟踪的车辆
			for (key in this.vehicles) {
				this.vehicles[key].if_track = false;
			}
		}
		v.if_track = !v.if_track;
		return v.if_track;
	}
}

//轨迹
gmap.prototype.addTrackLine = function(vehicle, gps_datas, color, width) {
	var v = this.vehicles[vehicle.did];
	var content = "";
	if (v == null) {
		v = new vehicleMarker(vehicle, false, false);
		this.vehicles[vehicle.ObjectID] = v;
	}
	var points = [];
	var latLng;
	//画多边形
	// var bounds = new google.maps.LatLngBounds();
	//  var source = new ol.source.Vector();
	// var bounds = new ol.interaction.Draw({
	//             source: source,
	//             type: 'Polygon',
	//             freehand: false,  
	//             geometryFunction: ol.interaction.Draw.createBox()
	//         });
	for (var i = 0; i < gps_datas.length; i++) {
		//        if (this.map.getMapTypeId() == google.maps.MapTypeId.SATELLITE || this.map.getMapTypeId() == google.maps.MapTypeId.HYBRID) {
		//            latLng = new google.maps.LatLng(gps_datas[i].lat, gps_datas[i].lon);
		//        } else {
		latLng = [gps_datas[i].lon, gps_datas[i].lat];
		//        }
		points.push(latLng);
		// bounds.extend(latLng);
	}
	console.log(JSON.stringify(points))

	var polyOptions = {
		path: points,
		strokeColor: color,
		strokeOpacity: 0.7,
		strokeWeight: width
	}
	if (v.track_line) {
		v.track_line.setMap(null);
	};
	this.map.getView().setZoom(9)
	this.map.getView().setCenter(points[0])
	// v.track_line = new google.maps.Polyline(polyOptions);
	//创建一个线
	var Line = new ol.Feature({
		geometry: new ol.geom.LineString(points)
	});
	//设置线的样式
	Line.setStyle(new ol.style.Style({
		//边线颜色
		stroke: new ol.style.Stroke({
			color: '#749AE2',
			width: 5
		}),
	}));

	//实例化一个矢量图层Vector作为绘制层
	var source = new ol.source.Vector({
		features: [Line]
	});
	//创建一个图层
	var vector = new ol.layer.Vector({
		source: source
	});
	//将绘制层添加到地图容器中
	this.map.addLayer(vector);


	// v.track_line.setMap(this.map);
	// this.map.fitBounds(bounds);
}

gmap.prototype.removeTrackLine = function(vehicle) {
	var v = this.vehicles[vehicle.ObjectID];
	var content = "";
	if (v != null && v.track_lines != null) {
		for (var i = 0; i < v.track_lines.length; i++) {
			v.track_lines[i].setMap(null);
		}
		v.track_line.setMap(null);
		v.track_line = null;
	}
}

gmap.prototype.moveTrackPoint = function(vehicle, gps_data, if_open_win) {
	var v = vehicle;
	v.active_gps_data.lon = gps_data.lon;
	v.active_gps_data.lat = gps_data.lat;
	v.active_gps_data.rev_lon = gps_data.rev_lon;
	v.active_gps_data.rev_lat = gps_data.rev_lat;
	v.active_gps_data.speed = gps_data.speed;
	v.active_gps_data.direct = gps_data.direct;
	v.active_gps_data.gps_time = gps_data.gps_time;
	v.active_gps_data.uni_status = gps_data.uni_status;
	v.active_gps_data.uni_alerts = gps_data.uni_alerts;
	this.updateVehicle(v, true, true, if_open_win, 'green', 3, true);
}
function strPad(hex) {
	var zero = '00000000';
	var tmp = 8 - hex.length;
	return zero.substr(0, tmp) + hex;
}

gmap.prototype.openAddGeoTool = function() {
	google.maps.event.addListener(this.map, 'click', function(event) {
		//alert(event.latLng);
		var lon = parseInt(event.latLng.lat() * 600000);
		var lat = parseInt(event.latLng.lng() * 600000);
		lon = strPad(lon.toString(16).toUpperCase());
		lat = strPad(lat.toString(16).toUpperCase());
		alert(lat + "," + lon);
	});
}

var onMapClick = function(map, title, div_content) {
	return function(event) {
		switch (toolType) {
			case TOOL_TYPE_POI:
				//alert("兴趣点：" + event.latLng);
				if (current_infowin) {
					current_infowin.close();
				}
				current_infowin = new google.maps.InfoWindow({
					content: div_content,
					disableAutoPan: true
				});
				if (current_marker) {
					current_marker.setMap(null);
				}
				current_marker = new google.maps.Marker({
					position: event.latLng,
					map: map,
					title: title
				});
				current_infowin.open(map, current_marker);
				break;
			case TOOL_TYPE_GEO:
				//alert("矩形围栏：" + event.latLng);
				if (current_infowin) {
					current_infowin.close();
				}
				current_infowin = new google.maps.InfoWindow({
					content: div_content,
					disableAutoPan: true,
					position: event.latLng
				});
				if (current_retangle) {
					current_retangle.setMap(null);
				}
				current_retangle = new google.maps.Rectangle({
					strokeColor: "#FF0000",
					strokeOpacity: 0.8,
					strokeWeight: 2,
					fillColor: "#FF0000",
					fillOpacity: 0.35,
					map: map,
					bounds: getRectangle(event.latLng.lng(), event.latLng.lat(), 100)
				});
				current_infowin.open(map);
				break;
			case TOOL_TYPE_POLY:
				alert("多边形围栏：" + event.latLng);
				break;
			case TOOL_TYPE_ROUTE:
				alert("线路：" + event.latLng);
				break;
		}
	}
}

gmap.prototype.setTool = function(tool_type, title, div_content, callback) {
	toolType = tool_type;
	switch (tool_type) {
		case TOOL_TYPE_DEFAULT:
			google.maps.event.removeListener(this.mapClick);
			if (current_infowin) {
				current_infowin.close();
			}
			if (current_marker) {
				current_marker.setMap(null);
			}
			break;
		case TOOL_TYPE_POI:
		case TOOL_TYPE_GEO:
		case TOOL_TYPE_POLY:
		case TOOL_TYPE_ROUTE:
			fn = onMapClick(this.map, title, div_content);
			this.mapClick = google.maps.event.addListener(this.map, 'click', fn);
			break;
	}
}

gmap.prototype.addPois = function(pois) {
	var p = null;
	var latLng = null;
	var icon = "";
	var title = "";
	for (var i = 0; i < pois.length; i++) {
		this.addPoi(pois[i]);
	}
}

gmap.prototype.addPoi = function(poi) {
	var p = null;
	var latLng = null;
	var icon = "";
	var title = "";
	var p = this.pois[poi.PointID];
	// 判断兴趣点是否存在，存在则更新数据，不存在则添加
	if (p != null) {
		this.updatePoi(poi);
	} else {
		//        if (this.map.getMapTypeId() == google.maps.MapTypeId.SATELLITE || this.map.getMapTypeId() == google.maps.MapTypeId.HYBRID) {
		//            latLng = new google.maps.LatLng(poi.lat, poi.lon);
		//        } else {
		latLng = new google.maps.LatLng(poi.Lat, poi.Lon);
		//        }
		p = new poiMarker(poi);
		var offset = getTextWidth(poi.PointName) / 2 + 25;
		//      console.log(poi.PointName + "," + offset);
		icon = getPoiIcon(poi, MAP_TYPE_GOOGLE, offset);
		title = poi.PointName;
		//      p.marker_ = new MarkerWithLabel({
		//          title: title,
		//          position: latLng,
		//          icon: icon,
		//          map: this.map, 
		//          draggable: false,
		//          raiseOnDrag: false,
		//          labelContent: poi.PointName,
		//          labelAnchor: new google.maps.Point(50, -10),
		//          labelClass: "labels", // the CSS class for the label
		//          labelStyle: { opacity: 0.75 }
		//      });
		p.marker_ = new google.maps.Marker({
			position: latLng,
			icon: icon,
			map: this.map,
			title: title,
			label: {
				fontSize: '10px',
				fontWeight: 'normal',
				text: title
			}
		});
		this.pois[poi.PointID] = p;
		this.poi_markers.push(p.marker_);
	}

}

gmap.prototype.findPoi = function(poi_id) {
	var p = this.pois[poi_id];
	var content = "";
	if (p != null) {
		var latLng;
		//        if (this.map.getMapTypeId() == google.maps.MapTypeId.SATELLITE || this.map.getMapTypeId() == google.maps.MapTypeId.HYBRID) {
		//            latLng = new google.maps.LatLng(p.lat, p.lon);
		//        } else {
		latLng = new google.maps.LatLng(p.rev_lat, p.rev_lon);
		//        }
		this.map.setZoom(10);
		this.map.setCenter(latLng);
		return p;
	}

}

gmap.prototype.editPoi = function(div_content, poi_id, callback) {
	//找到对应的poi
	var p = this.pois[poi_id];
	if (p) {
		var latLng;
		//        if (this.map.getMapTypeId() == google.maps.MapTypeId.SATELLITE || this.map.getMapTypeId() == google.maps.MapTypeId.HYBRID) {
		//            latLng = new google.maps.LatLng(p.lat, p.lon);
		//        } else {
		latLng = new google.maps.LatLng(p.rev_lat, p.rev_lon);
		//        }
		this.map.setZoom(10);
		this.map.setCenter(latLng);
		current_infowin = new google.maps.InfoWindow({
			content: div_content,
			disableAutoPan: true
		});
		if (current_marker) {
			current_marker.setMap(null);
		}
		current_marker = new google.maps.Marker({
			position: p.marker_.position,
			map: this.map,
			title: p.poi_name
		});
		current_infowin.open(this.map, current_marker);
		//current_marker = p.marker_;
		this.setTool(TOOL_TYPE_POI, p.poi_name, div_content, callback);
	}
}

gmap.prototype.updatePoi = function(poi) {
	var p = this.pois[poi.PointID];
	var content = "";
	if (p != null) {
		//        if (this.map.getMapTypeId() == google.maps.MapTypeId.SATELLITE || this.map.getMapTypeId() == google.maps.MapTypeId.HYBRID) {
		//            latLng = new google.maps.LatLng(poi.lat, poi.lon);
		//        } else {
		latLng = new google.maps.LatLng(poi.Lat, poi.Lon);
		//        }
		p.poi_name = poi.PointName;
		p.poi_type = poi.PointType;
		p.lon = poi.Lon;
		p.lat = poi.Lat;
		var icon = getPoiIcon(poi, MAP_TYPE_GOOGLE);
		p.marker_.setIcon(icon);
		var latLng;
		//        if (this.map.getMapTypeId() == google.maps.MapTypeId.SATELLITE || this.map.getMapTypeId() == google.maps.MapTypeId.HYBRID) {
		//            latLng = new google.maps.LatLng(poi.lat, poi.lon);
		//        } else {
		latLng = new google.maps.LatLng(poi.Lat, poi.Lon);
		//        }
		p.marker_.setPosition(latLng);
		//      p.marker_.label.marker_.labelContent = poi.poi_name;
		//      p.marker_.label.setContent();
		//      p.marker_.label.marker_.labelAnchor = new google.maps.Point(50, -10),
		//      p.marker_.label.setAnchor();
	}
}

gmap.prototype.deletePoi = function(poi_id) {
	var p = this.pois[poi_id];
	if (p != null) {
		// 从数组中删除对象
		this.pois[poi_id] = null;
		if (p.marker_) {
			p.marker_.setMap(null);
		}
	}
}

gmap.prototype.clearPoi = function() {
	for (var i = 0; i < this.poi_markers.length; i++) {
		var m = this.poi_markers[i];
		if (m) {
			m.setMap(null);
		}
	}
	this.poi_markers = [];
	this.pois = [];
}

//lon,lat: 中心点经纬度
//meter: 半径，单位(米)
var getRectangle = function(lon, lat, meter) {
	var pi = 3.1415926535897932;
	var ranx, rany;
	var x, y;
	y = lat;
	x = 90 - y;
	x = Math.sin(x * pi / 180);
	x = 40075.38 * x;
	x = x / 360;
	x = x * 1000;
	ranx = meter / x;
	rany = meter / 110940;
	return new google.maps.LatLngBounds(
		new google.maps.LatLng(lat - rany, lon - ranx),
		new google.maps.LatLng(lat + rany, lon + ranx)
	);
}

gmap.prototype.showGeo = function(poi) {
	var latLng;
	//    if (this.map.getMapTypeId() == google.maps.MapTypeId.SATELLITE || this.map.getMapTypeId() == google.maps.MapTypeId.HYBRID) {
	//        latLng = new google.maps.LatLng(poi.lat, poi.lon);
	//    } else {
	latLng = new google.maps.LatLng(poi.rev_lat, poi.rev_lon);
	//    }
	this.map.setZoom(15);
	this.map.setCenter(latLng);
	if (current_retangle) {
		current_retangle.setMap(null);
	}
	current_retangle = new google.maps.Rectangle({
		strokeColor: "#FF0000",
		strokeOpacity: 0.8,
		strokeWeight: 2,
		fillColor: "#FF0000",
		fillOpacity: 0.35,
		map: this.map,
		bounds: getRectangle(latLng.lng(), latLng.lat(), poi.width)
	});
}

gmap.prototype.deleteGeo = function() {
	if (current_retangle) {
		current_retangle.setMap(null);
	}
}

//更改电子围栏宽度
gmap.prototype.changeGeoWidth = function(width) {
	if (current_retangle) {
		var bounds = getRectangle(current_retangle.getBounds().getCenter().lng(), current_retangle.getBounds().getCenter().lat(),
			width);
		current_retangle.setBounds(bounds);
	}
}

gmap.prototype.editGeo = function(div_content, poi, callback) {
	//找到对应的poi
	var p = poi;
	if (poi) {
		var latLng;
		//        if (this.map.getMapTypeId() == google.maps.MapTypeId.SATELLITE || this.map.getMapTypeId() == google.maps.MapTypeId.HYBRID) {
		//            latLng = new google.maps.LatLng(p.lat, p.lon);
		//        } else {
		latLng = new google.maps.LatLng(p.rev_lat, p.rev_lon);
		//        }
		this.map.setZoom(15);
		this.map.setCenter(latLng);
		current_infowin = new google.maps.InfoWindow({
			content: div_content,
			disableAutoPan: true,
			position: latLng
		});
		if (current_retangle) {
			current_retangle.setMap(null);
		}
		current_retangle = new google.maps.Rectangle({
			strokeColor: "#FF0000",
			strokeOpacity: 0.8,
			strokeWeight: 2,
			fillColor: "#FF0000",
			fillOpacity: 0.35,
			map: this.map,
			bounds: getRectangle(latLng.lng(), latLng.lat(), p.width)
		});
		current_infowin.open(this.map);

		this.setTool(TOOL_TYPE_GEO, p.poi_name, div_content, callback);
	}
}
