var en = {
	translation: {
		"app": {
			"name": "WiCARE"
		},
		"login": {
			"email": "Account",
			"email2": "Mobile phone or email",
			"password": "Password",
			"auto": "Auto Sign in",
			"signin": "Sign in",
			"signup": "Sign Up",
			"forgot": "Forget?",
			"update": "Update Now",
			"cancel": "Cancel",
			"logininfo": "The information has expired. Please log in again",
			"loginerr": "Wrong account or password, please check",
			"exit": "Tap again to exit"
		},
		"reg": {
			"title": "Sign Up",
			"email": "Account",
			"email2": "Mobile phone or email",
			"code": "PIN",
			"getcode": "Get Code",
			"password": "Password (6 - 20 length)",
			"passconfirm": "Password Confirm (6 - 20 length)",
			"signup": "Sign Up",
			"passfail": "Password confirmation failed.",
			"signsucce": "Sign up successfully."
		},
		"account": {
			"title": "Account Information",
			"name": "Name",
			"email": "Email",
			"mobile": "Mobile",
			"sex": "Sex",
			"male": "Male",
			"female": "Female",
			"logo": "Avatar",
			"inputname": "Pls input new name",
			"inputemail": "Pls input new email",
			"selectphoto": "Pls select photo",
			"uploading": "Uploading...",
			"uploadfailed": "Upload failed.",
			"modifyphoto": "Modify Logo",
			"takephoto": "Take Picture",
			"selectphoto": "Select From Album",
			"removeaccount": "Delete Account",
			"removeaccount2": "Delete Account(Confirm again)",
			"removeconfirm": "Please note that after delete, all your information, including personal data, vehicle data and vehicle history data, will be cleared and cannot be retrieved. Are you sure you want to delete the account {{account}}?",
			"removereplysuccess": "Your application for deletion of account {{account}} has been submitted. We will process it within 72 hours. Please wait patiently.",
			"removereplyfailed": "Your application to delete account {{account}} failed. Please try again。"
		},
		"forgetpassword": {
			"title": "Modify Password",
			"email": "Account",
			"email2": "Mobile phone or email",
			"code": "PIN (4 length)",
			"newpass": "New Password (6 to 20 length)",
			"newpassconfirm": "Password Confirm (6 to 20 length)",
			"modify": "Modify",
			"codeerr": "PIN is wrong",
			"getcode": "Get PIN",
			"modifysucce": "Modify password successfully."
		},
		"appjs": {
			"passlen": "Password length is 6 at least",
			"account": "Account is invalid",
			"passerr": "Password is wrong",
			"notaccount": "Account cannot be empty.",
			"inputemail": "Please input valid email.",
			"sendcodesucc": "SMS verification code sent",
			"sendcodefail": "SMS verification code sending failed, please try again",
			"sendcode": "PIN have been sended to your email.",
			"codefail": "PIN sended failed, Pls try again later.",
			"passnull": "Password cannot be empty.",
			"passlenm": "Password's length must be 6 at least",
			"passcon": "Password confirm cannot be empty.",
			"passlencon": "Password confirm's length must be 6 at least.",
			"passsame": "Two passwords must be same.",
			"imeinull": "IMEI cannot be empty",
			"inputimei": "Pls input valid IMEI",
			"noimei": "IMEI not exists.",
			"hasimei": "IMEI has been binded to other vehicle, Pls change other IMEI.",
			"userimei": "User is not exist.",
			"planull": "Plate cannot be empty",
			"plaeexit": "Plate name is exist.",
			"emilltn": "Length of email should be 6 at least",
			"emailpas": "Length of Password should be 6 at least",
			"emialexit": "Email already exists.",
			"signupfail": "Sign Up failed, please try again.",
			"getuser": "Get user info failed, pls try again later.",
			"unkownerr": "Unknown error, pls re-login.",
			"saveinfofail": "Save user info failed, pls try again later.",
			"savealertfail": "Save alert option failed, pls try again later.",
			"getcust": "Get customer info failed, pls try again later.",
			"updatesust": "Update customer info failed, pls try again later.",
			"modifail": "Modify password failed, pls try again later.",
			"addvicdail": "Add vehicle failed, Pls try again.",
			"unkownerrlo": "Unknow error, Pls re-login and try again.",
			"updatevicfail": "Update vehicle failed, pls try again later.",
			"getcunfail": "Get customer list failed, pls try again later.",
			"getlistfail": "Get vehicle list failed, pls try again later.",
			"getdivecefail": "Get device list failed, pls try again later.",
			"delectvic": "Delete vehicle failed, pls try again later.",
			"getalertlist": "Get alert list failed, pls try again later.",
			"updatealertfail": "Update alert status failed, pls try again later.",
			"updatealertallfail": "Update all alert status failed, pls try again later.",
			"getpalyback": "'Get playback data failed, pls try again later."
		},
		"main": {
			"contorl": "Control",
			"more": "Location",
			"location": "Location"
		},
		"contorl": {
			"service": "Service expired, please renew in Vehicle Management!",
			"unlock": "Unlock successfully.",
			"lock": "Lock successfully.",
			"stop": "Stop successfully.",
			"start": "Start successfully.",
			"send": "Send successfully",
			"sendfail": "Sending failed, please try again",
			"servicexpi": "Service has expired, please recharge and renew!",
			"locking": "Locking...",
			"unlocking": "Unlocking...",
			"netword": "Please turn on Bluetooth or network connection",
			"plsselect": "Please select a vehicle",
			"opentrunk": "Are you sure to open the trunk?",
			"yes": "YES",
			"no": "NO",
			"constop": "Confirm to stop engine?",
			"constart": "Confirm to start engine?",
			"opentrunking": "Opening the trunk...",
			"looking": "Looking for car...",
			"satrteng": "Start Engine",
			"stopeng": "Stop Engine",
			"starting": "Starting engine...",
			"stoping": "Stopping engine...",
			"year": "year",
			"yuan": "money",
			"ren": "Renewal management",
			"cancel": "Cancel",
			"renone": "Renewal for 1 years",
			"rentwo": "Renewal for 2 years",
			"confirm": "Confirm",
			"rentip": "Insufficient balance, please recharge and try again !",
			"rencharge": "Confirm Recharge",
			"rensucc": "Renew Success",
			"conren": "Confirm renewal"
		},
		"vehiclelist": {
			"title": "Vehicle List",
			"zhongduan": "Terminal No",
			"gengxintime": "Refresh Time",
			"daoqitime": "Expire Time",
			"carset": "Set",
			"edit": "Edit"
		},
		"vehicleset": {
			"title": "Vehicle settings",
			"Remote": "Learning remote key",
			"UnlockSound": "Horn unlock",
			"LockSound": "Horn lock",
			"UnlockLamp": "Unlock flashing light",
			"LockLamp": "Lock  flashing light",
			"DoorLamp": "Open door flashing light",
			"CarWash": "PKE off",
			"StartTime": "Startup keep time",
			"ignitionTime": "Engine ignition keep time",
			"shock": "Vibration sensitivity",
			"shocklong": "high",
			"shockin": "Mid",
			"shockshort": "low",
			"long": "long",
			"in": "medium",
			"short": "short",
			"fuwu": "The service has expired, please recharge and renew",
			"sendimg": "Sending instructions...",
			"sendsuncess": "Send instruction successfully",
			"selectcar": "Please select a vehicle",
			"tip":"When the vehicle is unlocked, click on the learning remote control. After successfully sending the command, you will hear two beeps from the host. At this time, press and hold any key on the remote control and the host beeps once, which means the remote control has learned successfully. Press and hold any key on the other remote control and the host beeps twice. , Which means that the second remote control has been successfully learned, and the learning is now complete."
		},
		"Voicepush": {
			"title": "Push settings",
			"MessPush": "Information push",
			"VehicleUnlock": "The car is unlocked",
			"VehicleLock": "The car is locked",
			"VehicleStart": "Engine is started",
			"VehicleStall": "Engine is off",
			"bootOpen": "The tail box is opened",
			"bootClosed": "The tail box is closed",
			"DoorOpened": "The door is opened",
			"DoorClosed": "The door is closed",
			"LightNotoff": "The lights are not turned off",
			"DoorNotclosed": "The door is not closed",
			"VehicleNotlocked": "The car is not locked",
			"BatteryBoltage": "Low battery voltage",
			"shock": "Vibration alarm",
			"setsuc": "Parameters set successfully",
			"setfail": "Parameter setting failed, please try again!",
			"seting": "Parameter setting...."
		},
		"renew": {
			"title": "Renewal",
			"oneyears": "$19.99 for 1 year",
			"twoyears": "$38.99 for 2 year",
			"cirCom": "confirm",
			"canel": "cancel",
			"balance": "The balance is insufficient, please recharge and try again !",
			"recharge": "Confirm recharge",
			"success": "Successful renewal",
			"rerenew": "Confirm renewal"
		},
		"charge": {
			"title": "recharge",
			"amount": "Recharge amount",
			"pay": "Select Payment Method",
			"Wechat": "APPLE PAY",
			"immediately": "Recharge now",
			"Effective": "Please enter a valid amount"
		},
		"webviewfloat": {
			"add": "Add Vehicle",
			"edit": "Edit Vehicle",
			"plsselect": "Please select a vehicle"
		},
		"tabmore": {
			"vicmag": "Vehicle Management",
			"user": "Account:",
			"modypass": "Modify Password",
			"sysSet": "System settings",
			"version": "Version:",
			"exit": "Exit",
			"click": "Click twice more to enter debug mode",
			"logout": "Logout",
			"cancel": "Cancel",
			"wallet":"my account",
			"record":"Renew record"
		},
		"systemset": {
			"title": "System settings",
			"gesture": "Set up gesture lock",
			"pushvoice": "Information push",
			"setGps": "GPS switch",
			"gesturelock": "Gesture lock",
			"keepPas": "Password saved successfully",
			"againPas": "Input is inconsistent, re-enter",
			"lockSucc": "Successfully unlocked",
			"lockFail": "Unlock failed",
			"againIpu": "re-enter",
			"plsLock": "Please unlock",
			"draw": "Draw unlock pattern",
			"resetPas": "reset Password",
			"forgetPas": "forget password",
			"confirm": "confirm",
			"cancel": "cancel",
			"inputPas": "Enter login password",
			"forgetDraw": "Forget the gesture pattern",
			"verification":"Password validation",
			"pasError": "wrong password",
			"LockStart":"Gesture lock is enabled",
			 "lockClose":"Gesture lock is off"
		},
		"apnqurey": {
			"title": "Debug",
			"select": "Select",
			"send": "Send",
			"input": "Pls input command",
			"close": "Close Debug",
			"open": "Open Debug",
			"qurey": "Querying....",
			"sim": "View SIM card number",
			"ipaddress": "IP address and port number",
			"apnname": "APN node name",
			"exitgprs": "Exit GPRS mode",
			"entergprs": "Enter GPRS mode",
			"view": "View communication mode",
			"query": "Query mileage value",
			"version": "Software version",
			"terminal": "Terminal restart",
			"set": "Restore factory settings"
		},
		"vehicle": {
			"add": "Add Vehicle",
			"imei": "Scan QRCode / Input IMEI (*)",
			"palte": "Plate",
			"tip": "Notice: * is required field",
			"save": "Save",
			"delect": "Delete",
			"yes": "YES",
			"no": "NO",
			"confirm": "Confirm to delete",
			"delect": "Delete vehicle",
			"success": "Successfully",
			"delectvic": "Delete Vehicle",
			"addsuccen": "Add vehicle successfully.",
			"savecuccen": "Save vehicle successfully.",
			"paltmtip": "Plate cannot be empty"
		},
		"apn": {
			"apn": "APN-User",
			"apnpass": "APN-Password",
			"send": "Send",
			"user": "Pls input User",
			"pass": "Pls input password"
		},
		"palyback": {
			"palyback": "Playback",
			"upper": "Pre",
			"today": "Today",
			"lower": "Next",
			"starttime": "Begin Time: ",
			"endtime": "End Time: ",
			"Process": "Progress",
			"pause": "Pause",
			"speed": "Speed",
			"play": "Play",
			"Sunday": "Sun",
			"Monday": "Mon",
			"Tuesday": "Tue",
			"Wednesday": "Wed",
			"Thursday": "Thu",
			"Friday": "Fri",
			"Saturday": "Sat",
			"time": "Time",
			"Selectdate": "Please select the date",
			"starttime1": "Begin time",
			"endtime1": "End time",
			"load": "Loading",
			"nodata": "Vehicle has no data."
		},
		"submap": {
			"title": "Vehicle Monitor",
			"maptips": "Loading Map",
			"notTrack": "Untrace",
			"Track": "Trace",
			"mapatips": "Cannot get location"
		},
		"globaljs": {
			"notTrack": "Untrace",
			"Track": "Trace",
			"gettime": "Receive Time",
			"Positime": "Locate Time",
			"Accsta": "ACC status",
			"speed": "Speed",
			"direction": "Course",
			"balyback": "Playback",
			"Accstart": "ACC On",
			"Acclose": "ACC Off",
			"truenorth": "N",
			"Northeast": "NE",
			"Dueeast": "E",
			"Southeast": "SE",
			"Duesouth": "S",
			"Southwest": "SW",
			"Duewest": "W",
			"Northwest": "NW"
		},
		"problem": {
			"title": "Questions and Answers",
			"one": "The key cannot be automatically sensed",
			"two": "The horn does not sound when locked",
			"Three": "Unable to remotely turn off the engine",
			"Four": "Cannot start the vehicle remotely",
			"Five": "The APP display device is offline",
			"Six": "GPS display offline",
			"Seven": "Incorrect username or password",
			"Eight": "The  horn did not  work when Car seeking",
			"ten": "Why can't  mobile phone receive voice notifications?",
			"tentext": "Please log out of your account and log in again. If you still can��t solve it, please completely delete the app and reinstall it��",
			"onetext": "Confirm whether the remote control key has power, if there is no power, you need to replace the battery.Confirm whether  that  the remote control key cannot be automatically sensed is just happened. If it is, there may be magnetic interference in the place. It is recommended to use the mobile phone to unlock and try again in another place. Is it possible to open and close the lock with the remote control key? If yes, leave the car 5-8 meters with the remote control after unlocking to see if it can automatically lock the car. Some users are used to locking the car with keys when they leave, so that the automatically induction function is turned off, and they cannot be automatically unlocked the next time they approach the car.If none of the above can be confirmed, please go to the dealer to check the antenna and hardware.",
			"twotext": "Confirm whether you have entered the silent mode, the specific detection method is: close the door, short press the lock button, and then long press the lock button, the horn will call.If it is not silent mode, please go to the dealer to check whether there is a problem with the speaker wiring.",
			"Threetext": "Check if the key is near the car. If the key is close to the car and the device senses the key, it will think that the owner is about to drive, so the engine will not be remotely turned off.Confirm whether the door has been opened or closed during the startup process. If the door has been opened and closed during the startup process and the door has been closed for more than 15 seconds, the remote flameout will not be achieved. When the door is opened and closed, the flameout can be achieved within 15 seconds.If none of the above conditions exist, please go to the dealer to check the hardware equipment.",
			"Fourtext": "Please confirm whether the mobile phone APP is online and whether the key has power. If there is no problem, please go to the dealer to check the hardware equipment.",
			"Fivetext": "If you have been able to use the APP before and suddenly cannot use it, it may be that the communication signal of the on-board equipment is very weak, please move the vehicle to a place where there is a signal.The device comes with Bluetooth function, please turn on the Bluetooth of the phone, the APP will automatically search for Bluetooth and connect. The car can be controlled normally through the Bluetooth connection.If the APP shows that your service period has expired, please contact customer service to deal with it.",
			"Sixtext": "Please confirm whether the vehicle is parked in an open place and whether the device can receive satellite signals. At the same time, confirm whether the positioning antenna of the vehicle equipment is exposed. If there is no problem in the above situation, please go to the dealer to check.",
			"Seventext": "Please confirm whether your account number and password are entered correctly. If the account number is correct, you can reset the password through the 'Password Forgetted' on the login page.",
			"Eighttext": "Please confirm whether the engine is turned off and the door is locked. The car search function will only work 15 seconds after the engine is turned off and the door is locked. If there is no such problem, please confirm whether the product is connected to the speaker cable, if you are not clear, you can go to the dealer to check the hardware.",
		},
		"infonotice": {
			"title": "Notification",
			"vehicle": "Vehicle name",
			"notice": "Notification content",
			"Handle": "Confirm",
			"hulue": "Ignore",
			"day": "Days ago",
			"hour": "Hours ago",
			"minute": "Minutes ago",
			"now": "Now",
			"read": "Have read",
			"notread": "Unread",
			"contentinit": "Pull down to refresh",
			"contentdown": "Pull down to refresh",
			"contentrefresh": "Loading��",
			"contentnomore": "No data",
			"yes": "Yes",
			"no": "No",
			"updataall": "Confirm processing all messages?",
			"confim": "Processing messages"
		},
		"fuwu": {
			"name": "Service Agreement",
			"and": "and",
			"yinsi": "Privacy Policy",
			"agree": "Agree",
			"cip": "please click 'Agree' and start accepting our services."
		}
	}
}
