var bds = []; // 可连接设备列表
var deviceName = '';
var deviceId = '';
var _devs = {};
var bconnect = false;
var bss = []; // 连接设备服务列表
var serviceId = '0000FFE0-0000-1000-8000-00805F9B34FB';
var bscs = []; // 连接设备服务对应的特征值列表
var characteristicId = null;
var bscws = []; // 可写特征值列表
// var wcharacteristicId = '0000FFE1-0000-1000-8000-00805F9B34FB';
// var ncharacteristicId = '0000FFE2-0000-1000-8000-00805F9B34FB';
var wcharacteristicId = null;
var ncharacteristicId = null;
var notifyCallback;
var setapnCallback;
var statusCallback;
var sendCallback;
var _bconnect = false;
var blueMdtType = 1; //1: 老屠车控 2: 焦健车控
var available = true;
var ti=0;
// var sendtime;
var _frame = new Uint8Array();
var sendtime=setInterval(function(){
	ti++ 
	if(ti>=3){
		 ti=0;
	} 
 },100)
function concatenate(resultConstructor, ...arrays) {
	let totalLength = 0;
	for (let arr of arrays) {
		totalLength += arr.length;
	}
	let result = new resultConstructor(totalLength);
	let offset = 0;
	for (let arr of arrays) {
		result.set(arr, offset);
		offset += arr.length;
	}
	return result;
}
// 设置参数
function stringToByte(str) {
 var bytes = new Array();
 var len, c;
 len = str.length;
 for (var i = 0; i < len; i++) {
  c = str.charCodeAt(i);
  if (c >= 0x010000 && c <= 0x10FFFF) {
   bytes.push(((c >> 18) & 0x07) | 0xF0);
   bytes.push(((c >> 12) & 0x3F) | 0x80);
   bytes.push(((c >> 6) & 0x3F) | 0x80);
   bytes.push((c & 0x3F) | 0x80);
  } else if (c >= 0x000800 && c <= 0x00FFFF) {
   bytes.push(((c >> 12) & 0x0F) | 0xE0);
   bytes.push(((c >> 6) & 0x3F) | 0x80);
   bytes.push((c & 0x3F) | 0x80);
  } else if (c >= 0x000080 && c <= 0x0007FF) {
   bytes.push(((c >> 6) & 0x1F) | 0xC0);
   bytes.push((c & 0x3F) | 0x80);
  } else {
   bytes.push(c & 0xFF);
  }
 }
 return bytes;
}

function setParam(strCommand) {
 var buffer = stringToByte(strCommand);
 if (buffer) {
  sendValue(0x82, buffer);
 }
}

// 发送数据
function sendValue(cmdType, buffer) {
 if (!deviceId) {
  // log('未选择设备!');
  log('未选择设备!');
  return;
 }
 if (!bconnect) {
  // log('未连接蓝牙设备!');
  log('未连接蓝牙设备!');
  return;
 }
 if (!serviceId) {
  // log('未选择服务!');
  log('未选择服务!');
  return;
 }
 if (!wcharacteristicId) {
  // log('未选择写入的特征值!');
  log('未选择写入的特征值!');
  return;
 }
 var _buffer = wrapData(cmdType, buffer);
 var content = buffer2hex(_buffer);
 log('发送数据'+content)
 // log('写入蓝牙设备的特征值数据: ' + content);
 //分包发送
console.log(ti)
//  //启动定时器 间隔3豪秒发送一次
 if(ti!=3){
	 _sendValue(_buffer, cmdType);
	 // log('写入蓝牙设备的特征值数据结束: ' + content); 
 }
		
	

}

// 分包发送函数
function _sendValue(_buffer, _cmd_type){
 var _frame = [];
 var _rest = [];
 if(_buffer.length < 17){
  _frame = _buffer;
  _buffer = [];
 }else{
  _frame = _buffer.slice(0, 15);
  _buffer.splice(0, 15);
 }
 var content = buffer2hex(_frame);
 var rest_content = buffer2hex(_buffer);
 log('发送一帧数据：' + content);
 log('剩余帧数据：' + rest_content);
 plus.bluetooth.writeBLECharacteristicValue({
  deviceId: deviceId,
  serviceId: serviceId,
  characteristicId: wcharacteristicId,
  value: _frame,
  success: function(e) {
   if (_cmd_type !== 0x81) {
    if (sendCallback) {
     sendCallback(true);
    }
   }
   log('写入数据成功, ' + content);
   if(_buffer.length > 0){
    _sendValue(_buffer, _cmd_type);
   }
  },
  fail: function(e) {
   if (_cmd_type !== 0x81) {
    if (sendCallback) {
     sendCallback(false);
    }
   }
   log('写入数据失败!, ' + content + ',' + JSON.stringify(e));
  }
 }); 
}
function resetapn(text) {
 return text;
}
// 蓝牙初始化操作 
var blueInit = function() {
	// 监听蓝牙适配器状态变化
	plus.bluetooth.onBluetoothAdapterStateChange(function(e) {
		log('onBluetoothAdapterStateChange: ' + JSON.stringify(e));
		log(JSON.stringify(e.available))
		log(JSON.stringify(available))
		log(JSON.stringify(!e.available && available))
		log(JSON.stringify(!e.available && !available))
		log(JSON.stringify(e.available && !available))
		if (!e.available && available||!e.available && !available) {
			log("停止搜索,关闭蓝牙")
			available = e.available;
			disconnectDevice();
			stopDiscovery();
			closeBluetooth();
			
		} else if (e.available && !available) {
			log("开始搜索,开启蓝牙")
			available = e.available;
			closeBluetooth();

				setTimeout(function() {
					openBluetooth();
				}, 1000);

		
		}
        
		if (!e.discovering) {
			//如果蓝牙适配器不处于搜索状态,则开始搜索蓝牙设备
			console.log("如果蓝牙适配器不处于搜索状态,则开始搜索蓝牙设备")
			startDiscovery();
		}
	});
	//  监听搜索到新设备 
	plus.bluetooth.onBluetoothDeviceFound(function(e) {
		var devices = e.devices;
		log('onBluetoothDeviceFound: ' + devices.length);
		for (var i in devices) {
			log(JSON.stringify(devices[i]));
			var device = devices[i];
			if (device.deviceId /*&&device.name&&device.name.length>0&&device.name!='null'*/ ) {
				bds.push(device);
			}
		}

		var device = devices.find(item => item.name === deviceName)
		log('found 1 for - ' + deviceName + ':' + JSON.stringify(device));
		if (device) {
			log('found 2 for - ' + deviceName + ':' + JSON.stringify(device));
			deviceId = device.deviceId;
			// 保存已搜索到的device
			_devs[deviceName] = device;
			log('开始连接蓝牙：' + deviceId + ',' + deviceName);
			// setTimeout(function() {
			// if(device.RSSI > -90){
			// log('开始连接蓝牙：' + deviceId + ',' + deviceName);
			// connectDevice();	
			// }
			// }, 1000)
			connectDevice();
		}
	});
	//  监听低功耗蓝牙设备连接状态变化 
	plus.bluetooth.onBLEConnectionStateChange(function(e) {
		log('onBLEConnectionStateChange: ' + JSON.stringify(e));
		log('状态'+deviceId == e.deviceId)
		if (deviceId == e.deviceId) { // 更新连接状态
			_bconnect = e.connected;
			// if (statusCallback) {
			// 	statusCallback(bconnect);
			// }
			log('判断'+!e.connected)
			if (!e.connected) {
				// _frame = new Uint8Array();
				// stopDiscovery();
				// startDiscovery();
				// connectDevice();
				log(JSON.stringify(e.connected))
				bconnect = e.connected;
				if (statusCallback) {
					log('返回')
					statusCallback(bconnect);
				}
				wcharacteristicId = null;
				ncharacteristicId = null;
				console.log("6666")
				checkAndConnectDevice();
			} else {
				// setTimeout(getServices, 2000);
			}
		}
	});
	// 监听低功耗蓝牙设备的特征值变化 
	plus.bluetooth.onBLECharacteristicValueChange(function(e) {
	  // log('onBLECharacteristicValueChange: ' + JSON.stringify(e));
	  // var value = buffer2hex(e.value);
	  var _fragment = new Uint8Array(e.value);
	  // log('_fragment = ' + _fragment);
	  // log('_frame = ' + _frame);
	  if (_frame.length > 0) {
	   _frame = concatenate(Uint8Array, _frame, _fragment);
	  } else {
	   _frame = _fragment;
	  }
	
	  // log('_frame2 = ' + buffer2hex(_frame));
	
	  if (_fragment[_fragment.length - 1] !== 0x0F) {
	   return;
	  }
	  if (notifyCallback) {
	   var obj = unwrapData(_frame);
	   // log("cmd类型"+JSON.stringify(obj.cmd_type))
	   
	   // log('数据：' + JSON.stringify(obj));
	   if (obj.cmd_type === 0x01) {
		console.log('心跳数据：' + JSON.stringify(obj));
	    // log('心跳数据：' + JSON.stringify(obj));
	    if (obj.frame[0] === 0x00) {
	     if (obj.frame[1] === 0x30) {
	      blueMdtType = 1;
	     } else if (obj.frame[1] === 0x50) {
	      blueMdtType = 2;
	     }
	    } else if (obj.frame[0] === 0x01) {
	
	    }
	   } else if (obj.cmd_type === 0x02) { //设置参数回复
		console.log('设置参数回复原始数据：' + JSON.stringify(obj));
	    log('设置参数回复原始数据：' + JSON.stringify(obj));
		log('设置参数回复数据：' + bin2String(obj.frame));
		var bluePage = plus.webview.getWebviewById('blueLinkTimer.html');
		mui.fire(bluePage, 'bluechange', {
			set: bin2String(obj.frame)
		});
		// resetapn(bin2String(obj.frame))
			// setapnCallback(bin2String(obj.frame))
		// notifyCallback(bin2String(obj.frame))
	    // 需要在设置页面定义回调函数，再次进行调用显示回复数据
	   } else if (obj.cmd_type === 0x10) { //调试信息
	   log('调试原始数据：' + JSON.stringify(obj));
	    log('调试数据：' + bin2String(obj.frame));
         var bluePage = plus.webview.getWebviewById('tab-more-apnqurey');
         mui.fire(bluePage, 'blueapndata', {
         	set: bin2String(obj.frame)
         });
	    // 需要在设置页面定义回调函数，再次进行调用显示回复数据
	   } else if (obj.cmd_type === 0x09) {
	    // log('_frame2 = ' + buffer2hex(_frame));
	    log('读取数据：' + JSON.stringify(obj));
	    if (blueMdtType === 1) {
	     // notifyCallback(_frame);
	     var rlen = obj.len;
	     var offset = 0;
	     while (rlen > 0) {
	      var sub_cmd = obj.frame[0 + offset];
	      var sub_len = obj.frame[1 + offset];
	      var sub_frame = obj.frame.slice(2 + offset, 2 + offset + sub_len);
	      log('指令：' + sub_cmd + '，数据包：' + sub_frame);
	      if (sub_cmd === 0x21) {
	       notifyCallback(sub_frame);
	      }
	      rlen = rlen - 2 - sub_len;
	      offset += 2 + sub_len;
	     }
	    } else if (blueMdtType === 2) {
	     var rlen = obj.len;
	     var offset = 0;
	     while (rlen > 0) {
	      var sub_cmd = obj.frame[0 + offset];
	      var sub_len = obj.frame[1 + offset];
	      var sub_frame = obj.frame.slice(2 + offset, 2 + offset + sub_len);
	      log('数据包：' + sub_frame);
	      if (sub_cmd === 0x15) {
	       var msg = getMsg(sub_frame);
	       app.toast(msg);
	      } else if (sub_cmd === 0x14) {
	       notifyCallback(sub_frame);
	      }
	      rlen = rlen - 2 - sub_len;
	      offset += 2 + sub_len;
	     }
	    }
	   }
	   _frame = new Uint8Array();
	  }
	 });
};

function bin2String(array) {
  return String.fromCharCode.apply(String, array);
}

function getMsg(buf) {
	var msg = '';
	if (buf[0] === 1 && buf[1] === 1 && buf[2] === 1) {
		msg = '打开中控锁成功'
	} else if (buf[0] === 1 && buf[1] === 1 && buf[2] === 0) {
		msg = '打开中控锁失败'
	} else if (buf[0] === 1 && buf[1] === 0 && buf[2] === 1) {
		msg = '关闭中控锁成功'
	} else if (buf[0] === 1 && buf[1] === 0 && buf[2] === 0) {
		msg = '关闭中控锁失败'
	} else if (buf[0] === 7 && buf[1] === 1) {
		msg = '寻车成功'
	} else if (buf[0] === 7 && buf[1] === 0) {
		msg = '寻车失败'
	} else if (buf[0] === 6 && buf[1] === 1) {
		msg = '开后尾箱成功'
	} else if (buf[0] === 6 && buf[1] === 0) {
		msg = '开后尾箱失败'
	} else if (buf[0] === 5 && buf[1] === 0x0A && buf[2] === 1) {
		msg = '远程启动成功'
	} else if (buf[0] === 5 && buf[1] === 0x0A && buf[2] === 2) {
		msg = '远程启动失败，车子已经启动了'
	} else if (buf[0] === 5 && buf[1] === 0x0A && buf[2] === 3) {
		msg = '远程启动失败，远程启动时间需要大于或等于5分钟'
	} else if (buf[0] === 5 && buf[1] === 0x0A && buf[2] === 4) {
		msg = '远程启动失败，执行远程启动流程后，读不到转速'
	} else if (buf[0] === 5 && buf[1] === 0x0A && buf[2] === 5) {
		msg = '远程启动失败，没有在设防状态下'
	} else if (buf[0] === 5 && buf[1] === 0x0A && buf[2] === 0) {
		msg = '远程启动失败，没有在设防状态下'
	} else if (buf[0] === 8 && buf[1] === 1) {
		msg = '远程熄火成功'
	} else if (buf[0] === 8 && buf[1] === 2) {
		msg = '远程熄火失败，现在不在远程启动状态下'
	} else if (buf[0] === 8 && buf[1] === 3) {
		msg = '远程熄火失败，执行熄火流程后还读得到转速'
	} else if (buf[0] === 8 && buf[1] === 4) {
		msg = '远程熄火失败，车子已经在熄火状态了'
	} else if (buf[0] === 8 && buf[1] === 5) {
		msg = '远程熄火失败，有速度，不能熄火'
	}
	return msg;
}

function log(s) {
	console.log(s);
	var _dout_ = document.getElementById("logBox");
	var controlPage = plus.webview.getWebviewById('tab-webview-subpage-control.html');
	mui.fire(controlPage, 'bluelog', {
		log: s + "\n"
	});
	if (_dout_) {
		_dout_.value += s + "\n";
		(0 == _dout_.scrollTop) && (_dout_.scrollTop = 1); //在iOS8存在不滚动的现象	
	}
}

// 重设数据 
function resetDevices(d, s) {
	// d || (bds = [], deviceId = null, document.getElementById('deivce').value = '');
	// s || (bss = [], serviceId = null, document.getElementById('service').value = '');
	// bscs = [], bscws = [], characteristicId = null, wcharacteristicId = null, document.getElementById('characteristic').value =
	// 	'', document.getElementById('wcharacteristic').value = '';
}

function buffer2hex(value) {
	var t = '';
	if (value) {
		var v = new Uint8Array(value);
		for (var i in v) {
			t += '0x' + v[i].toString(16) + ' ';
		}
	} else {
		t = '无效值';
	}
	return t;
}

function checkAndConnectDevice() {
	console.log("获取已搜索")
	// log('set bluetooth timer 1');
	// var id2 = setInterval(function(){
	// 	log("bluetooth timer");
	// }, 1000);
	// log('set bluetooth timer 2');
	// var dev = _devs[deviceName];
	// log('dev: ' + JSON.stringify(dev));
	// if (dev) {
	// 	stopDiscovery();
	// 	deviceId = dev.deviceId;
	// 	setTimeout(connectDevice(), 1000);
	// } else {
	// 获取已经搜索的蓝牙设备
	plus.bluetooth.getBluetoothDevices({
		success: function(e) {
			var devices = e.devices;
			log('get devices success: ' + JSON.stringify(e));
			for (var i in devices) {
				console.log(i + ': ' + JSON.stringify(devices[i]));
			}
            //localName
			var device = devices.find(item => item.name === deviceName)
			log('get devices - found 1 for - ' + deviceName + ':' + JSON.stringify(device));
			if (device) {
				log('get devices - found 2 for - ' + deviceName + ':' + JSON.stringify(device));
				deviceId = device.deviceId;
				// 保存已搜索到的device
				_devs[deviceName] = device;
				log('开始连接蓝牙：' + deviceId + ',' + deviceName);
				// setTimeout(function() {
				// if(device.RSSI > -90){
				// log('开始连接蓝牙：' + deviceId + ',' + deviceName);
				// connectDevice();	
				// }
				// }, 1000)
				connectDevice();
			} else {
				// 打开搜索，搜索新的设备
				stopDiscovery();
				startDiscovery();
			}
		},
		fail: function(e) {
			console.log('get devices failed: ' + JSON.stringify(e));
		}
	});
	
	
	
	// }
}

// 打开蓝牙 
function openBluetooth(did, callback, _statusCallback, _sendCallback) {
	log('断开原有蓝牙适配器');
	log('bconnect'+bconnect)
	if (bconnect) {
		console.log("6666")
		bconnect = false;
		wcharacteristicId = null;
		ncharacteristicId = null;
		if (statusCallback) {
			statusCallback(bconnect);
		}
		// disconnectDevice();
		closeBluetooth();
	}
	log('打开新的蓝牙适配器：');
	log('did：'+did);
	if (did) {
		deviceId = '';
		deviceName = 'XC' + did;
		notifyCallback = callback;
		statusCallback = _statusCallback;
		sendCallback = _sendCallback;
	}

	plus.bluetooth.openBluetoothAdapter({
		success: function(e) {
			log('打开成功!');
			available=true;
			checkAndConnectDevice();
		},
		fail: function(e) {
			log('打开失败! ' + JSON.stringify(e));
		}
	});
}

// 关闭蓝牙
function closeBluetooth() {
	log('关闭蓝牙适配器：');
	resetDevices();
	// if(available){
		plus.bluetooth.closeBluetoothAdapter({
			success: function(e) {
				log('关闭成功!');
				bconnect = false;
				ncharacteristicId = null;
				wcharacteristicId = null;
			},
			fail: function(e) {
				log('关闭失败! ' + JSON.stringify(e));
			}
		});
	// }
	
}

// 开始搜索蓝牙设备 
function startDiscovery() {
	log('开始搜索蓝牙设备：');
	resetDevices();
	console.log('蓝牙设备状态:'+available)
	if(available){
		plus.bluetooth.startBluetoothDevicesDiscovery({
			services: [serviceId],
			// allowDuplicatesKey: false,
			// interval: 1000,
			success: function(e) {
				log('开始搜索成功!');
			},
			fail: function(e) {
				log('开始搜索失败! ' + JSON.stringify(e));
			}
		});
	}
	
}

// 停止搜索蓝牙设备 
function stopDiscovery() {
	log('停止搜索蓝牙设备：');
	log('停止搜索'+available)
	if(available){
		plus.bluetooth.stopBluetoothDevicesDiscovery({
			success: function(e) {
				log('停止搜索成功!');
			},
			fail: function(e) {
				log('停止搜索失败! ' + JSON.stringify(e));
			}
		});
	}

}

// 连接蓝牙设备 
function connectDevice() {
	// app.toast('连接设备: ' + deviceId);
	if (!deviceId) {
		log('未选择设备!');
		return;
	}
	// if(bconnect){
	// 	bconnect=false;
	// 	if(statusCallback){
	// 		statusCallback(bconnect)
	// 	}
	// }
	log('连接设备: ' + deviceId);
	plus.bluetooth.createBLEConnection({
		deviceId: deviceId,
		success: function(e) {
			log('连接蓝牙成功!');
			// stopDiscovery();
			// beginLink();
			// var timer1 = setTimeout(function() {
			// getServices();
			// }, 2000);
			// getCharacteristics();
		},
		fail: function(e) {
			log('连接失败! ' + JSON.stringify(e));
			setTimeout(function(){
				connectDevice();
			},5000)
			
		}
	});
}

// 断开蓝牙设备
function disconnectDevice() {
	if (!deviceId) {
		// log('未选择设备!');
		return;
	}
	endLink();
	// resetDevices(true);
	log('断开蓝牙设备连接：');
	// if(available){
	plus.bluetooth.closeBLEConnection({
		deviceId: deviceId,
		success: function(e) {
			log('断开连接成功!');
			bconnect = false;
			if(statusCallback){
				statusCallback(bconnect);
			}
			wcharacteristicId = null;
			ncharacteristicId = null;
		},
		fail: function(e) {
			log('断开连接失败! ' + JSON.stringify(e));
		}
	});	
	// }
	
}

// 获取设备服务 
function getServices() {
	if (!deviceId) {
		log('未选择设备!');
		return;
	}
	if (!bconnect) {
		log('未连接蓝牙设备!');
		return;
	}
	// resetDevices(true);
	log('获取蓝牙设备服务:');
	var _id = setTimeout(function() {
		log('获取蓝牙设备服务2:');
		plus.bluetooth.getBLEDeviceServices({
			deviceId: deviceId,
			success: function(e) {
				var services = e.services;
				log('获取服务成功! ' + services.length);
				if (services.length > 0) {
					for (var i in services) {
						bss.push(services[i]);
						log(JSON.stringify(services[i]));
						if (bss[i].uuid === '0000FFE0-0000-1000-8000-00805F9B34FB') {
							serviceId = '0000FFE0-0000-1000-8000-00805F9B34FB';
							var _id2 = setTimeout(function() {
								getCharacteristics();
								clearTimeout(_id2);
							}, 5000);
							break;
						}
					}
				} else {
					log('获取服务列表为空?');
				}
			},
			fail: function(e) {
				log('获取服务失败! ' + JSON.stringify(e));
				disconnectDevice();
				connectDevice();
				// stopDiscovery();
				// startDiscovery();
			}
		});
		clearTimeout(_id);
	}, 5000);
	log('获取蓝牙设备服务3, id = ' + _id);
}

// 获取服务的特征值 
function getCharacteristics() {
	if (!deviceId) {
		log('未选择设备!');
		return;
	}
	if (!_bconnect) {
		log('未连接蓝牙设备!');
		return;
	}
	if (!serviceId) {
		log('未选择服务!');
		return;
	}
	// resetDevices(true, true);
	log('获取蓝牙设备指定服务的特征值:');
	plus.bluetooth.getBLEDeviceCharacteristics({
		deviceId: deviceId,
		serviceId: serviceId,
		success: function(e) {
			var characteristics = e.characteristics;
			log('获取特征值成功! ' + characteristics.length);
			if (characteristics.length > 0) {
				for (var i in characteristics) {
					var characteristic = characteristics[i];
					log(JSON.stringify(characteristic));
					if (characteristic.properties) {
						if (characteristic.properties.read) {
							bscs.push(characteristics[i]);
						}
						if (characteristic.properties.write) {
							bscws.push(characteristics[i]);
							if (characteristic.properties.notify || characteristic.properties.indicate) {
								plus.bluetooth.notifyBLECharacteristicValueChange({ //监听数据变化
									deviceId: deviceId,
									serviceId: serviceId,
									characteristicId: characteristic.uuid,
									success: function(e) {
										log('notifyBLECharacteristicValueChange ' + characteristic.uuid + ' success.');
									},
									fail: function(e) {
										log('notifyBLECharacteristicValueChange ' + characteristic.uuid + ' failed! ' + JSON.stringify(
											e));
									}
								});
								if (characteristic.uuid === '0000FFE1-0000-1000-8000-00805F9B34FB') {
									wcharacteristicId = characteristic.uuid
									bconnect = true;
									if (statusCallback) {
										statusCallback(bconnect);
									}
									// 查询状态
									queryStatus();
									// 开始握手
									beginLink();
								} else if (characteristic.uuid === '0000FFE2-0000-1000-8000-00805F9B34FB') {
									ncharacteristicId = characteristic.uuid
								}
							}
						}
					}
				}
			} else {
				log('获取特征值列表为空?');
			}
		},
		fail: function(e) {
			log('获取特征值失败! ' + JSON.stringify(e));
			console.log(wcharacteristicId)
			console.log(bconnect)
			// bconnect = false;
			// if (statusCallback) {
			// 	statusCallback(bconnect);
			// }
			// disconnectDevice();    //断开蓝牙设备
			// connectDevice();   //连接蓝牙
			// stopDiscovery();    //停止搜索蓝牙
			// startDiscovery();   //开始搜索蓝牙
		}
	});
}

// 开始发送握手
var _linkTask = null;

function beginLink() {
	log('开启心跳');
	var _linkTask = setInterval(function() {
		// log('心跳...');
		// link();
	}, 2000);
}

function endLink() {
	log('结束心跳');
	if (_linkTask) {
		clearInterval(_linkTask);
	}
}

// 握手
function blueLink() {
	if (_bconnect) {
		if(!wcharacteristicId){
			getCharacteristics();
		}else{
			log('发送心跳...');
			var buffer = null;
			buffer = [0];
			if (buffer) {
				sendValue(0x81, buffer);
			}	
		}
	}
}
// 开启调试
function opendebug() {
	if (bconnect) {
		log('开启调试...');
			var buffer = null;
			buffer = [2];
			if (buffer) {
				sendValue(0x81, buffer);
			}	
	}
}
function closedebug() {
	if (bconnect) {
			var buffer = null;
			buffer = [3];
			if (buffer) {
				sendValue(0x81, buffer);
			}	
	}
}

// 查询状态
function queryStatus() {
	console.log("获取状态2")
	var buffer = [1];
	if (buffer) {
		sendValue(0x81, buffer);
	}
}

// 锁车
function blueLock() {
	var buffer = null;
	if (blueMdtType === 1) {
		buffer = [0x82, 0x02, 0x40, 0x00];
	} else if (blueMdtType === 2) {
		buffer = [0x15, 0x02, 0x01, 0x00];
	}

	if (buffer) {
		sendValue(0x89, buffer);
	}
}

// 解锁
function blueUnlock() {
	var buffer = null;
	if (blueMdtType === 1) {
		buffer = [0x82, 0x02, 0x08, 0x00];
	} else if (blueMdtType === 2) {
		buffer = [0x15, 0x02, 0x01, 0x01];
	}

	if (buffer) {
		sendValue(0x89, buffer);
	}
}

// 启动
function blueStart() {
	var buffer = null;
	if (blueMdtType === 1) {
		buffer = [0x82, 0x02, 0x40, 0x10];
	} else if (blueMdtType === 2) {
		buffer = [0x15, 0x02, 0x05, 0x0A];
	}

	if (buffer) {
		sendValue(0x89, buffer);
	}
}

// 熄火
function blueStop() {
	var buffer = null;
	if (blueMdtType === 1) {
		buffer = [0x82, 0x02, 0x40, 0x10];
	} else if (blueMdtType === 2) {
		buffer = [0x15, 0x01, 0x08, 0x75];
	}

	if (buffer) {
		sendValue(0x89, buffer);
	}
}

// 寻车
function blueFindCar() {
	var buffer = null;
	if (blueMdtType === 1) {
		buffer = [0x82, 0x02, 0x01, 0x00];
	} else if (blueMdtType === 2) {
		buffer = [0x15, 0x02, 0x07, 0x03];
	}

	if (buffer) {
		sendValue(0x89, buffer);
	}
}

// 开后尾箱
function blueOpenTrailer() {
	var buffer = null;
	if (blueMdtType === 1) {
		buffer = [0x82, 0x02, 0x00, 0x80];
	} else if (blueMdtType === 2) {
		buffer = [0x15, 0x02, 0x06, 0x01];
	}

	if (buffer) {
		sendValue(0x89, buffer);
	}
}

// 关后尾箱
function blueCloseTrailer() {
	var buffer = null;
	if (blueMdtType === 1) {
		buffer = [0x82, 0x02, 0x00, 0x80];
	} else if (blueMdtType === 2) {
		buffer = [0x15, 0x02, 0x06, 0x00];
	}

	if (buffer) {
		sendValue(0x89, buffer);
	}
}

var seqNo = 0;

var getValidCode = function(buf) {
	var code = 0;
	// log('获取校验码：' + buffer2hex(buf));
	for (var i = 1; i < buf.length; i++) {
		code = code ^ buf[i];
	}
	return code;
};

function wrapData(cmdType, buffer) {
	var _buffer = [];
	var len = buffer.length;
	// 包头
	_buffer.push(0xF0);
	_buffer.push(seqNo++ & 0xFF);
	_buffer.push(cmdType);
	_buffer.push(len);
	_buffer = _buffer.concat(buffer);
	var valid_code = getValidCode(_buffer);
	_buffer.push(valid_code);
	_buffer.push(0x0F);
	return _buffer;
}

function unwrapData(buffer) {
	// log("接收数据:" + buffer[0] + ',' + buffer[buffer.length - 1]);
	var frame = null;
	var cmd_type = 0;
	var len = 0;
	if (buffer[0] === 0xF0 && buffer[buffer.length - 1] === 0x0F) {
		cmd_type = buffer[2];
		len = buffer[3];
		frame = buffer.slice(4, 4 + len);
	}
	// log("接收数据结束." + buffer[0] + ',' + buffer[buffer.length - 1]);

	return {
		cmd_type: cmd_type,
		len: len,
		frame: frame
	};
}
